﻿:Class jquerydemo : MildPage

    :Include #.HTMLInput

    ∇ Render req;tabnames;welcome;datepicker;data;tablesorter;content;headers;accordion;html;list1;list2;sortable;js;style
      :Access Public
⍝ set up the Tabs widget to display other widgets
      tabnames←'Welcome!' 'DatePicker' 'TableSorter' 'Accordion' 'Sortable' ⍝'Draggable'
⍝ set up the Welcome tab content
      welcome←BRA'h3'Enclose'Welcome to the JQuery demonstration page!'
      welcome,←BRA'This page contains tabs that demostrate a variety of JQuery widgets and plug-ins.'
      welcome,←BRA'In fact, the tabs themselves are implemented using JQuery''s Tabs widget.'
⍝ set up the DatePicker tab content
      datepicker←(#.HTML.h2'DatePicker')
      datepicker,←BRA'Using Multiple Months and yyyy-mm-dd format'
      datepicker,←2 BRA'Date: ',req #.JQueryUtils.DatePicker'mydate1'('' 20)'numberOfMonths: 3,showButtonPanel: true,dateFormat: "yy-mm-dd"'
      datepicker,←BRA'Using Month and Year Menus and DD, dd MM yyyy format'
      datepicker,←'Date: ',req #.JQueryUtils.DatePicker'mydate2'('' 30)'changeMonth: true,changeYear: true,dateFormat: "DD, d MM yy"'
⍝ set up the TableSorter tab content
      data←4 3⍴'Name' 'Age' 'Sex' 'Fred' 35 'Male' 'Susan' 50 'Female' 'Chris' 18 'Female'
      tablesorter←(#.HTML.h2'TableSorter'),'Click on column heading to sort by that column'
      tablesorter,←BRA req #.JQueryUtils.TableSorter'mytable'(data'' '' '' 1)''
⍝ set up the Accordion tab content
      content←3⍴⊂''
      content[1]←⊂TextToHTML #.Files.GetText req.Server.Root,'Data/sample1.txt'
      content[2]←⊂'pre style="font-family:APL385;font-size:12px"'Enclose APLToHTML ⎕VR '#.HTMLInput.Attrs' ⍝ <br/>APLToHTML ⎕VR⊃⎕SI
      content[3]←⊂#.Files.GetText req.Server.Root,'Data/sample.htm'
      headers←'Some Text' 'Some APL Code' 'Some HTML'
      accordion←(#.HTML.h2'Accordion'),'style' 'width:600px; height:400px;'#.HTML.div req #.JQueryUtils.Accordion'myaccordion' headers content 'fillSpace: true'
⍝ set up the Sortable tab content
      style←⊂'#s1' '#s2'MakeStyle'list-style-type' 'none' 'margin' 0 'padding' 0 'float' 'left' 'margin-right' '10px' 'background' '#eee' 'padding' '5px' 'width' '143px'
      style,←⊂'#s1 li' '#s2 li'MakeStyle'margin' '5px' 'padding' '5px' 'font-size' '1.2em' 'width' '120px'
      style←'style'Enclose style
      list1←'To Do' 'Wash Car' 'Vacuum' 'Laundry' 'Cut Grass' 'Clean Garage'
      list2←'Done' 'Go Fishing'
      list1 list2←'li class="ui-state-default"'∘Enclose¨¨list1 list2
      (1⊃list1)←'ui-state-disabled'#.JQueryUtils.insertClass 1⊃list1
      (1⊃list2)←'ui-state-disabled'#.JQueryUtils.insertClass 1⊃list2
      list1←'ul id="s1"'Enclose list1
      list2←'ul id="s2"'Enclose list2
      js←JS'$("#s1, #s2").sortable({connectWith: "ul", items: "li:not(.ui-state-disabled)"}).disableSelection();'
      sortable←style,CRLF,(BRA 'Drag items between lists'),list1,CRLF,list2,CRLF,js
      sortable←'div style="height:400px"'Enclose (#.HTML.h2'Sortable Lists'),sortable
⍝ set up the Tabs
      html←(#.HTML.h2'Tabs'),(2 BRA 'a href="/"' Enclose 'Home'),req #.JQueryUtils.Tabs'mytabs' tabnames(welcome datepicker tablesorter accordion sortable)''
      req.Return html
    ∇

:EndClass