﻿:Class misc
⍝ Private User Command

    ⎕IO←1 ⋄ ⎕ML←1

    ∇ r←List
      :Access Shared Public
      r←⎕NS¨1⍴⊂⍬
⍝ Name, group, short description and parsing rules
      r.Name←⊂'assemblies'
      r.Group←⊂'wsutils'
      r[1].Desc←'show loaded assemblies in memory'
      r.Parse←⊂''
    ∇

    ∇ r←Run(Cmd Args);⎕USING
      :Access Shared Public
      :Select Cmd
      :Case 'assemblies'
          r←'(No assemblies currently loaded)'
          :Trap 90
              ⎕USING←'System'
              r←↑⍕¨AppDomain.CurrentDomain.GetAssemblies
          :EndTrap
      :EndSelect
    ∇

    ∇ r←Help Cmd;⎕ML
      :Access Shared Public
      ⎕ML←1
      :Select Cmd
      :Case 'assemblies'
          r←'Show all assemblies currently loaded into  memory'
      :EndSelect
    ∇

:EndClass
